from taipy.gui import Gui
import hashlib
import json
import codecs, os
from taipy.gui import Html
import pandas as pd
import requests
import statistics
from databases import db
pwd = os.getcwd()

HTML = os.path.join(pwd,"html", "index.html")
file_read = codecs.open(HTML, "r", "utf-8")
index = file_read.read()
html_page_index = Html(index)
def extractConfig(nameModel="SystemData",relPath=os.path.join(pwd,"conf/experiment_config.json"),dataOut="keyantrophics"):
    configPath=os.path.join(os.getcwd(),relPath)
    with open(configPath, 'r', encoding='utf-8') as file:
        config = json.load(file)[nameModel]
    Output= config[dataOut]
    return Output
mode_list=extractConfig(nameModel="SystemData",dataOut="mode_list")
def getmetricvoice(model):
    rows = db(db.analitic_voice.model==model).select()
    rows_list = rows.as_list()
    data=pd.DataFrame(rows_list)
    durationL=list()
    for i in rows_list:
        durationL.append(db(db.trusted.path == i["path"] ).select().last().duration)
    duration=statistics.mean(durationL)
    time=pd.pivot_table(data,values=['time','similarity', 'similaritypartial'],index="model")['time'].values[0]
    similarity=pd.pivot_table(data,values=['time','similarity', 'similaritypartial'],index="model")['similarity'].values[0]
    similaritypartial=pd.pivot_table(data,values=['time','similarity', 'similaritypartial'],index="model")['similaritypartial'].values[0]
    efectivetime=time/duration
    return ({"model":model,"duration":duration,"time":time,"similarity":similarity,"similaritypartial":similaritypartial,"efectivetime":efectivetime})

def html_getmetricvoice():
    models=list()
    for row in db().select(db.analitic_voice.model, distinct=True):
        models.append(row.model)
    data={}
    for model in models:
        data[model]=getmetricvoice(model)
    data=pd.DataFrame(data).T
    datafiles={}
    for row in db().select(db.analitic_voice.ALL):
        datafiles[row.id]=row.as_dict()
    datafiles=pd.DataFrame(datafiles).T
    html="""
    <taipy:table>{data_voice}</taipy:table>
    <taipy:table filter=True>{data_files_voice}</taipy:table>
    """

    return html,data,datafiles
html_page_getmetricsvoice,data_voice,data_files_voices=html_getmetricvoice()

mode="voice"
modetypedata="audio"
file="id2"
def changemenu(mode):
    if mode_list[mode]=="audio":
        pathori="example/audio"
    if mode_list[mode]=="factura":
        pathori="example/factura"
    if mode_list[mode]=="texto":
        pathori="example/texto"
    seltypedata=mode_list[mode]  
    dir_list = os.listdir(pathori)
    
    return pathori,seltypedata,dir_list


def trustedallhtml(mode):
    pathori,seltypedata,dir_list=changemenu(mode)


    textmode=""
    for modeused in mode_list.keys():
        textmode=textmode+"('%s','%s'),"%(modeused,modeused)
    html="""<taipy:selector lov="{[%s]}" dropdown True on_change=changemenu>{sel}</taipy:selector>"""%(textmode) 
    Sal=""
    for i in dir_list:
        temp="""('%s', '%s'),"""%(str(pwd+"/"+pathori+"/"+i),str(i))
        Sal=Sal+temp
    html2="""<taipy:selector lov="{[%s]}" dropdown True >{sel2}</taipy:selector>"""%(Sal)
    return html+html2

html_page_trustedall = Html(trustedallhtml(mode))
#print(sel,sel2,seltypedata)
HTML = os.path.join(pwd,"html", "index.html")
file_read = codecs.open(HTML, "r", "utf-8")
index = file_read.read()
html_page_index = Html(index)

data=pd.DataFrame({'col1': [1, 2], 'col2': [3, 4]})

pages = {
  "/": html_page_index ,
  "getmetricsvoice": Html(html_page_getmetricsvoice),
  "trustedall":html_page_trustedall
}

app = Gui(pages=pages)
if __name__=="__main__":
    app.run(use_reloader=True,port=7882, change_delay=1600)#state.imageActive2,
